#include <cstdlib>
#include <sys/time.h>

#include "ticktimer.h"

using namespace std;

TickTimer::TickTimer() {
    gettimeofday(&_tv, NULL);
}

double TickTimer::tick() {
    double result;

    time_t old_sec = _tv.tv_sec;
    suseconds_t old_usec = _tv.tv_usec;
    gettimeofday(&_tv, NULL);

    time_t new_sec = _tv.tv_sec;
    suseconds_t new_usec = _tv.tv_usec;

    result = (new_sec - old_sec) + (new_usec - old_usec)/1000000.0;
    return result;
}


double TickTimer::probe() {
    double result;
    time_t old_sec = _tv.tv_sec;
    suseconds_t old_usec = _tv.tv_usec;

    timeval tv;
    gettimeofday(&tv, NULL);
    time_t new_sec = tv.tv_sec;
    suseconds_t new_usec = tv.tv_usec;

    result = (new_sec - old_sec) + (new_usec - old_usec)/1000000.0;
    return result;
}
